#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <math.h>
#include <XRS/Simple.h>
#include <XRS/Control.h>
#include <sys/time.h>
using namespace XRS;

#define PI M_PI        // ߼Ψ
#define MAX(x,y)  ((x>y)?(x):(y))
#define MIN(x,y)  ((x<y)?(x):(y))


/****************************************************
                ѿؿ
****************************************************/

double   Dt,Dx;             // ֥ƥå,֥ƥå
double   *x=NULL,*y=NULL;
double   t;                 // 
double   L;                 // ƥॵ
int      N=0,N0;            // γҿ
int      pause_time=50;     // ɽ٤(msec)
void     init(int);         // γҤν
void     move(int);         // γҤν
void     plot(int);         // 

/***************************************************
                
***************************************************/
#include <boost/random.hpp>
using namespace boost;
// 륻̥ĥˡ( Seed=42) Ȥ
mt19937            gen(42);

// 0.01.0μ¿ΰפ
uniform_real<> dst_uniform(-1.0,1.0);
variate_generator<mt19937, uniform_real<> > rand_uniform( gen, dst_uniform );

// 0,1פ
uniform_smallint<> dst01(0,1);
variate_generator<mt19937, uniform_smallint<> > rand01(gen, dst01);
 

/****************************************************
                   ᥤ 
*******************************************************/

int main(int argc,char **argv)
{
  if(argc>1) N0=atoi(argv[1]); else N0=1000;
  if(argc>2) Dt=atof(argv[2]); else Dt=1.0;
  if(argc>3) Dx=atof(argv[3]); else Dx=1;
  if(argc>4) L=atof(argv[4]);  else L=50;

  init(0);                   // γҤν

  while(1){
    plot(0);                 // 
    for(int n=0; n<N; n++) move(n);  // 1ƥåפλȯŸ
    t+=Dt;
  } 
}


/*********************************************************
                  γҤν 
*********************************************************/
   
void init(int mouse)
{
  if(x!=NULL || y!=NULL){ delete [] x; delete [] y; }
  N=N0;
  x=new double [N]; y=new double [N];

  if(mouse==3){
     //֡    
     for(int n=0; n<N; n++){ x[n]=L*rand_uniform(); y[n]=L*rand_uniform(); } 
  }else{
     //٤Ƹ֤
     for(int n=0; n<N; n++){ x[n]=y[n]=0.0; }  
  }
  plot(1);                 
}


/*********************************************************
                  γҤư 
*********************************************************/
   
void move(int n)
{
  //Υ
  //  x[n]+=Dx*(2*rand01()-1); y[n]+=Dx*(2*rand01()-1); 

  //
  double th=M_PI*rand_uniform();
  double c=cos(th),s=sin(th);
  x[n]+=Dx*c; y[n]+=Dx*s; 
  if(x[n]>L){ x[n]-=2.0*L;} if(x[n]<-L){ x[n]+=2.0*L;}
  if(y[n]>L){ y[n]-=2.0*L;} if(y[n]<-L){ y[n]+=2.0*L;}
}



/*******************************************************
             եå
********************************************************/

Simple_Window  Win;
Control_Window CW;
Display  *d=Win.disp();
GC       gc0=graphic_context("green");
GC       gc1=graphic_context("red");
GC       white=graphic_context("white");
GC       black=graphic_context("black");
int      width=500,dispstep=1,pr=5;

int xtoi(double x){ return int(0.5*(x/L+1)*width+0.5); }


void plot(int reset)
{
  static int initial=-1, count=0;
  static int *i=NULL,*j=NULL;

  if(initial<0){
    i=new int [N]; j=new int [N];
    for(int n=0; n<N; n++){ i[n]=j[n]=0;}
    CW.title("parameters");
    CW<<t<<"t"<<init<<"initial"
      <<PARAMETER<<pause_time<<"slow"<<N0<<"N";
    Win.geometry(width,width)<<"snapshot";
    initialize();     
    initial=0;
  }

  if(reset){  
      Win.clear();
      if(i!=NULL || j!=NULL){ delete [] i; delete [] j; }
      i=new int [N]; j=new int [N];
      for(int n=0; n<N; n++){ i[n]=j[n]=0;}
  }
  
  checkevent();

  if(count%dispstep==0){
      Win.clear();
      //    for(int n=0; n<N; n++) XFillArc(d,Win,white,i[n],j[n],pr,pr,0,23040);

    struct timespec req={0,long(pause_time*1E6)};
    nanosleep(&req,NULL);
    
    for(int n=0; n<N; n++){
      i[n]=xtoi(x[n]);
      j[n]=xtoi(y[n]);
      XFillArc(d,Win,gc0,i[n],j[n],pr,pr,0,23040);
    }

    count=0;
  }

  count++;
}
